#Copyright A. Grau

from uspp import *
import signal 
import sys
import socket
import winsound
from threading import Thread, Lock
from VideoCapture import Device
#import subprocess

import string,cgi,time
from os import curdir, sep
from BaseHTTPServer import BaseHTTPRequestHandler, HTTPServer
#import pri



def docapture():
    global cam, shutdown, camlock
    print "docapture"      
    while (not shutdown):      
      camlock.acquire()
      cam.saveSnapshot(curdir +'/data/lastsnap.jpg')
      camlock.release()      
      time.sleep(0.1)
    print "finished capture"
    


def opentty():
    global tty
    tty=SerialPort("COM2", 1000, 19200)
    purgedata()

def closetty():
    global tty
    #del tty

def purgedata():
    global tty
    time.sleep(0.05)
    s = ""
    while tty.inWaiting() > 0:
      s += tty.read()
    print s    
      

def setdatamode(datamode):
        global tty
        #opentty()
        s = ("%c%c%c%c%c%c%c" % (0xE6, 0xB5, 0xBA, 0xB9, 0xB2, 0xB3, 0xA9 ))
        if datamode:
            print "Datenmodus"
            s += "d"
        else:
            print "Programmiermodus"
            s += "p"
        tty.write(s)
        purgedata()
        #closetty()


class MyHandler(BaseHTTPRequestHandler):

    binaryExtensions = ['.gif', '.png', '.jpg']
    contentTypes = {
        '.css': 'text/css',
        '.gif': 'image/gif',
        '.jpg': 'image/jpg',
        '.png': 'image/png',
        'html': 'text/html',
    }


    def do_GET(self):
        global tty, camlock                
        """ Implementing the GET method """
        try:                                    
            if self.path == '/': self.path = '/index.html'
            path = self.path                  
            if (path.find('?') != -1):
              (path, params)  = path.split('?')
            print path                                
                        
            if path.startswith("/control"):
              # /control?m1=+1&m2=+0              
              print "control"
              params = params.split('&')                            
              sm1 = params[0].split('=')[1]
              sm2 = params[1].split('=')[1]
              print "sm1=", sm1
              print "sm2=", sm2
              m1 = int(sm1)
              m2 = int(sm2)              
              if (sm1.startswith('+') or sm1.startswith('-')):                              
                if m1 == -1:
                  tty.write("2")
                  purgedata()
                elif m1 == 1:
                  tty.write("1")
                  purgedata()
              else:
                tty.write("m1=" + sm1 + "*")
                purgedata()
              if (sm2.startswith('+') or sm2.startswith('-')):                   
                if m2 == -1:
                  tty.write("3")
                  purgedata()
                elif m2 == 1:
                  tty.write("4")
                  purgedata()
              else:
                tty.write("m2=" + sm2 + "*")
                purgedata()
              
               
              self.send_response(200)
              self.send_header('Content-type',	'text/html')
              self.end_headers()
              #print params
            else:                                        
              mode = 'r'
              if path[-4:] in self.binaryExtensions: mode = 'rb'              
              if path == '/lastsnap.jpg': camlock.acquire()
              fp = open(curdir + "/data/" + path[1:], mode)
              data = fp.read()
              fp.close()
              if path == '/lastsnap.jpg': camlock.release()
              # Send response
              self.send_response(200)
              self.send_header('Content-Type', self.__getContentType())
              self.send_header('Transfer-Encoding', 'chunked')
              self.end_headers()
              # time.sleep(0.2)
              self.wfile.write(data)
        except IOError:
            self.send_error(404, "File not found: %s" % path)
 
    def __getContentType(self):
        """ Function to figure out content types """
        content_type = 'text/plain'
        extension = self.path[-4:]
        if extension in self.contentTypes:
            content_type = self.contentTypes[extension]            
        return content_type

     

def signal_handler(signal, frame):
    global server
    print 'You pressed Ctrl-C!'
    server.socket.close()
    sys.exit(0)

            

def main():
    global server, cam, shutdown, tty, camlock       
    
    try:
        shutdown=False        
        # signal.signal(signal.SIGINT, signal_handler)
        print socket.gethostbyname(socket.gethostname())
        
        camlock = Lock()        
        cam = Device()
        cam.setResolution(320, 240)  
        t = Thread(target=docapture)
        t.start()
        
        tty=SerialPort("COM2", 1000, 19200)
        purgedata()
        setdatamode(True)                
        
        server = HTTPServer(('', 8080), MyHandler)        
        print 'started httpserver...'
                
        server.serve_forever()
    except KeyboardInterrupt:
        print '^C received, shutting down server'        
        shutdown=True
        setdatamode(False)
        closetty()        
        server.socket.close()        
                        

if __name__ == '__main__':
    main()

